#include <sourcemod>

new Handle:hRate = INVALID_HANDLE;
new Handle:hCmdRate = INVALID_HANDLE;
new Handle:hUpdateRate = INVALID_HANDLE;
new Handle:hMotd = INVALID_HANDLE;
new Handle:hHostname = INVALID_HANDLE;

new String:CmdString[192],
	String:motd[192],
	String:hostname[192];

public Plugin:myinfo = 
{
	name = "Forcerate",
	author = "Lomaka",
	description = "Automatically corrects rates of client",
	version = "1.0-RC1",
	url = "http://bisoftgames.ucoz.ru"
}

public OnPluginStart()
{
	hRate = CreateConVar("sm_rate", "20000", "Forcerate default rate.", FCVAR_PLUGIN, true, 10.0, true, 100000.0);
	hCmdRate = CreateConVar("sm_cmdrate", "100", "Forcerate default cl_cmdrate.", FCVAR_PLUGIN, true, 10.0, true, 1000.0);
	hUpdateRate = CreateConVar("sm_updaterate", "100", "Forcerate default cl_updaterate.", FCVAR_PLUGIN, true, 10.0, true, 1000.0);
	hMotd = CreateConVar("sm_motd", "motd.txt", "URL to motd file or by the motd file.", FCVAR_PLUGIN);
	
	HookEvent("player_activate", PlayerActivate, EventHookMode_Post);
	HookEvent("player_team", PlayerTeam, EventHookMode_Post);
	
	AutoExecConfig(true, "forcerate");
}

public OnConfigsExecuted()
{
	Format(CmdString, sizeof(CmdString), "rate %d;cl_cmdrate %d;cl_updaterate %d;chooseteam;", GetConVarInt(hRate), GetConVarInt(hCmdRate), GetConVarInt(hUpdateRate));
	
	hHostname = FindConVar("hostname");
	GetConVarString(hHostname, hostname, sizeof(hostname));
	
	GetConVarString(hMotd, motd, sizeof(motd));
	if(StrEqual("motd.txt",motd,false))
	{
		motd = "";
	}
}

public PlayerActivate(Handle:event, const String:name[], bool:dontBroadcast)
{
	EnforceRates(GetClientOfUserId(GetEventInt(event,"userid")));
}

public PlayerTeam(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetClientOfUserId(GetEventInt(event,"userid")) != 0)
	{
		CheckRates(GetClientOfUserId(GetEventInt(event,"userid")));
	}
}

CheckRates(client)
{
	QueryClientConVar(client, "rate", ConVarQueryFinished:ClientConVar, client);
	QueryClientConVar(client, "cl_cmdrate", ConVarQueryFinished:ClientConVar, client);
	QueryClientConVar(client, "cl_updaterate", ConVarQueryFinished:ClientConVar, client);
}

public ClientConVar(QueryCookie:cookie, client, ConVarQueryResult:result, const String:cvarName[], const String:cvarValue[])
{
	new rate, cmdrate, updaterate;
	rate = GetConVarInt(hRate);
	cmdrate = GetConVarInt(hCmdRate);
	updaterate = GetConVarInt(hUpdateRate);
	
	if(StrEqual("rate",cvarName,false))
	{
		if(StringToInt(cvarValue) != rate)
		{
			ClientCommand(client, "retry");
		}
	}
		
	if(StrEqual("cl_cmdrate",cvarName,false))
	{
		if(StringToInt(cvarValue) != cmdrate)
		{
			ClientCommand(client, "retry");
		}
	}
	
	if(StrEqual("cl_updaterate",cvarName,false))
	{
		if(StringToInt(cvarValue) != updaterate)
		{
			ClientCommand(client, "retry");
		}
	}
}

EnforceRates(client)
{
	new Handle:ForcerateMotd = CreateKeyValues("data");
	
	KvSetString(ForcerateMotd, "title", hostname);
	KvSetString(ForcerateMotd, "type", "2");
	KvSetString(ForcerateMotd, "msg", motd);
	KvSetString(ForcerateMotd, "cmd", CmdString);
	
	ShowVGUIPanel(client, "info", ForcerateMotd);
	
	CloseHandle(ForcerateMotd);
}

public OnClientSettingsChanged(client)
{
	if (IsClientInGame(client) && GetClientTeam(client))
	{
		CheckRates(client);
	}
}